;**************************************************************
;***    EMS45.ASM                                           ***
;***                                                        ***
;***    function        EMS_EmBlk.freeEM                    ***
;***                        : Boolean;                      ***
;***                                                        ***
;***    Releases an EMM handle along with the associated    ***
;***    pages.                                              ***
;***                                                        ***
;***                                                        ***
;***    (Ems Version 3.0)                                   ***
;**************************************************************

        .model  large,pascal   

        include emsdefs.asm 

        extrn   errno:WORD  

;
;   Define entry point
;
        public  EMS_EmBlk@freeEM

        .code

EMS_EmBlk@freeEM    proc    handle:Far Ptr Word

;
;   DX takes the number of pages to allocate:
;
        les     bx,handle
        mov     dx,es:[bx]              ; Get handle

        mov     ah,FreeEM               ; Move function code
        int     Ems                     ; Do the ems call

        or      ah,ah                   ; Set flags
        jnz     error

        xor     ax,ax                   ; AX gets 0
        ret                             ; Return to caller

error:
        mov     al,ah                   ; Transfer return code to al
        xor     ah,ah                   ; Zero high byte
        mov     errno,ax                ; Save in errno too
        ret                             ; Return to caller

EMS_EmBlk@freeEM    endp                ; End of procedure

        end                             ; End of source file
